/*
      5h@ 04

  2005/ 5/19 ˁ@P
*/
#include "B2Windef.h"
#include "classes.h"
#include <richedit.h>
#include <commctrl.h>

#pragma comment(lib, "comctl32.lib")

#define IDM_FILTER  3
#define IDM_DEL     4
#define IDM_DELFROM 5
#define IDM_NUM     6
#define IDM_OPEN    11
#define IDM_EXIT    12
#define IDM_SEL     21
#define IDM_COPY    22
#define IDM_CLR     23
#define IDM_ABOUT   31

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void filter();
void del();
void delFrom();
void num();

HINSTANCE g_hInstance;

HWND g_hwMain, g_hwView, g_hwStatus;
HWND g_hwKey, g_hwFilter, g_hwDelete, g_hwDelFrom, g_hwNum;

HMENU g_hMenu, g_hMenuFile, g_hMenuEdit, g_hMenuAbout;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow) {

	MSG msg;
	WNDCLASSEX wndclass;

	g_hInstance = hInstance;

	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = NULL;
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "R5TEXT";
	wndclass.hIconSm       = NULL;
	RegisterClassEx(&wndclass);

	LoadLibrary("RICHED20.DLL");

	/* CEChE쐬 */
	g_hwMain = CreateWindow ("R5TEXT", "5h@", WS_OVERLAPPEDWINDOW | WS_VISIBLE,
	  CW_USEDEFAULT, CW_USEDEFAULT, 640, 512,
	  NULL, NULL, hInstance, NULL);

	/* j[쐬 */
	g_hMenu = CreateMenu();
	g_hMenuFile = CreateMenu();
	g_hMenuEdit = CreateMenu();
	g_hMenuAbout = CreateMenu();

	AppendMenu(g_hMenuFile, MF_STRING, IDM_OPEN, "Ji&Oj");
	AppendMenu(g_hMenuFile, MF_SEPARATOR, 0, NULL);
	AppendMenu(g_hMenuFile, MF_STRING, IDM_EXIT, "Ii&Xj");

	AppendMenu(g_hMenuEdit, MF_STRING, IDM_SEL, "ׂđI(&L)");
	AppendMenu(g_hMenuEdit, MF_STRING, IDM_COPY, "ׂăRs[(&C)");
	AppendMenu(g_hMenuEdit, MF_STRING, IDM_CLR, "NA(&E)");

	AppendMenu(g_hMenuAbout, MF_STRING, IDM_ABOUT, "o[W(&A)");

	AppendMenu(g_hMenu, MF_POPUP, (UINT)g_hMenuFile, "t@Ci&Fj");
	AppendMenu(g_hMenu, MF_POPUP, (UINT)g_hMenuEdit, "ҏWi&Ej");

	AppendMenu(g_hMenu, MF_POPUP, (UINT)g_hMenuAbout, "o[W(&Hj");

	/* EChEɃj[jݒ */
	SetMenu(g_hwMain, g_hMenu);

	ShowWindow(g_hwMain, iCmdShow);

	/* bZ[W[v */
	while (GetMessage(&msg, NULL, 0, 0)) {

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return (int)msg.wParam;

}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	static OPENFILENAME ofn;
	static char lpszFn[256], lpszFt[256], lpszWrk[256];
	static PCHAR lpszOpen = "J";

	int iWidth, iHeight;
	RECT rec;

	static CHARRANGE cr;

	B2String1 *pbsTmp;

	HGLOBAL hMem;
	int iLength;
	char * lpszText;

	switch (iMsg) {

	case WM_CREATE:

		g_hwKey = CreateWindow("Edit", NULL,
		          WS_CHILD | WS_VISIBLE | WS_BORDER, 4, 4, 192, 24,
				  hwnd, (HMENU)0, g_hInstance, NULL);

		g_hwView = CreateWindow(RICHEDIT_CLASS, NULL, 
		           WS_CHILD | WS_VISIBLE | WS_BORDER | WS_HSCROLL | WS_VSCROLL |
 		           ES_MULTILINE | ES_AUTOVSCROLL  | ES_AUTOHSCROLL | ES_NOHIDESEL,
		           0, 0, 0, 0, hwnd, (HMENU)1, g_hInstance, NULL);

		g_hwFilter = CreateWindow("Button", "o",
		             WS_CHILD | WS_VISIBLE | BS_CENTER,
					 200, 4, 96, 24, hwnd, (HMENU)IDM_FILTER, g_hInstance, NULL);

		g_hwDelete = CreateWindow("Button", "폜",
		             WS_CHILD | WS_VISIBLE | BS_CENTER,
					 308, 4, 96, 24, hwnd, (HMENU)IDM_DEL, g_hInstance, NULL);

		g_hwDelFrom = CreateWindow("Button", "܂ō폜",
		             WS_CHILD | WS_VISIBLE | BS_CENTER,
					 416, 4, 96, 24, hwnd, (HMENU)IDM_DELFROM, g_hInstance, NULL);

		g_hwNum = CreateWindow("Button", "v",
		             WS_CHILD | WS_VISIBLE | BS_CENTER,
					 524, 4, 96, 24, hwnd, (HMENU)IDM_NUM, g_hInstance, NULL);

		/* b`eLXg̍ő啶4MBɐݒ */
		SendMessage(g_hwView, EM_EXLIMITTEXT, 0, (LPARAM)(4096 * 1024));

		g_hwStatus = CreateStatusWindow(WS_CHILD | WS_VISIBLE, NULL, hwnd, 0);

		// OPENFILENAME\̏
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = hwnd;
		ofn.hInstance = g_hInstance;
		ofn.lpstrFilter = "ׂẴt@C(*.*)\0*.*\0\0";
		ofn.lpstrCustomFilter = NULL;
		ofn.nMaxCustFilter = 0;
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = lpszFn;
		ofn.nMaxFile = 255;
		ofn.lpstrFileTitle = lpszFt;
		ofn.nMaxFileTitle = 255;
		ofn.lpstrInitialDir = NULL;
		ofn.lpstrTitle = NULL;
		ofn.Flags = 0;
		ofn.nFileOffset = 0;
		ofn.nFileExtension = 0;
		ofn.lpstrDefExt = NULL;
		ofn.lCustData = 0;
		ofn.lpfnHook = NULL;
		ofn.lpTemplateName = NULL;

		return 0;

	case WM_COMMAND:

		switch (LOWORD(wParam)) {

		/* o */
		case IDM_FILTER:

			filter();

			break;

		/* 폜 */
		case IDM_DEL:

			del();

			break;

		/* ܂ō폜 */
		case IDM_DELFROM:

			delFrom();

			break;

		/* v */
		case IDM_NUM:

			num();

			break;

		/* J */
		case IDM_OPEN:

			ofn.lpstrTitle = lpszOpen;
			ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

			if (!GetOpenFileName(&ofn)) {
				return 0;
			}

			pbsTmp = new B2String1();

			pbsTmp->loadFile(lpszFn);

			SetWindowText(g_hwView, pbsTmp->c_str());

			delete pbsTmp;

			break;

		/* I */
		case IDM_EXIT:

			DestroyWindow(hwnd);

			break;

		/* ׂđI */
		case IDM_SEL:

			cr.cpMin = 0;
			cr.cpMax = -1;

			SendMessage(g_hwView, EM_EXSETSEL, 0, (LPARAM)(&cr));

			break;

		/* ׂđI */
		case IDM_COPY:

			/* b`eLXg̕擾 */
			iLength = SendMessage(g_hwView, WM_GETTEXTLENGTH, 0, 0) + 1;

			/* IuWFNgm */
			hMem = GlobalAlloc(GHND, iLength);

			/* IuWFNgbNăAhX擾 */
			lpszText = (char *)GlobalLock(hMem);

			/* b`eLXg̕擾 */
			SendMessage(g_hwView, WM_GETTEXT, (WPARAM)iLength, (LPARAM)lpszText);

			/* IuWFNgAbN */
			GlobalUnlock(hMem);

			/* Nbv{[hI[v */
			OpenClipboard(hwnd);

			/* Nbv{[hNA */
			EmptyClipboard();

			/* Nbv{[hɃIuWFNg̕Rs[ */
			SetClipboardData(CF_TEXT, hMem);

			/* Nbv{[hN[Y */
			CloseClipboard();

			break;

		/* NA */
		case IDM_CLR:

			if (MessageBox(hwnd, "݂̓eׂď܂B",
				"mF", MB_OKCANCEL) != IDOK) {
				break;
			}

			SetWindowText(g_hwView, NULL);

			break;

		/* o[W */
		case IDM_ABOUT:

			MessageBox(hwnd, "5h@ 04 (C)2005 ˁ@P", "o[W", MB_OK);

			break;

		}

		return 0;

	/* EChETCYύX */
	case WM_SIZE:

		/* Xe[^Xo[ɃTCYύXʒm */
		SendMessage(g_hwStatus, WM_SIZE, LOWORD(lParam), 0);

		/* Xe[^Xo[̃TCY擾 */
		GetWindowRect(g_hwStatus, &rec);

		/* b`eLXg̃TCYvZ */
		iWidth = LOWORD(lParam);
		iHeight = HIWORD(lParam) - (32 + (rec.bottom - rec.top));

		/* b`eLXg̃TCYύX */
		SetWindowPos(g_hwView, hwnd, 0, 32, iWidth, iHeight, SWP_NOZORDER);

		return 0;

	case WM_DESTROY: /* I */

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

/* o */
void filter() {

	char aszKey[256], aszStatus[64];
	char *lpszText;

	GetWindowText(g_hwKey, aszKey, 256);

	if (lstrlen(aszKey) < 1) {
		return;
	}

	/* b`eLXg̕擾 */
	int iLength = SendMessage(g_hwView, WM_GETTEXTLENGTH, 0, 0) + 1;

	/* b`eLXg擾pobt@ */
	lpszText = new char[iLength];

	/* b`eLXg̕擾 */
	SendMessage(g_hwView, WM_GETTEXT, (WPARAM)iLength, (LPARAM)lpszText);

	/* 󂯎ŕNX */
	B2String1 *pbsText = new B2String1(lpszText);

	delete lpszText;

	/* s\nɓ */
	pbsText->replace("\r\n", "\n");

	/* sPʂɐ؂蕪 */
	B2Strings *pbssLine = pbsText->split("\n");

	delete pbsText;

	if (pbssLine == NULL) {

		SetWindowText(g_hwStatus, "");

		return;

	}

	int iLine = pbssLine->getSize();
	int iResultLine = 0;

	/* ʊi[p񐶐 */
	B2String1 *pbsResult = new B2String1();

	for (int i = 0;i < iLine;i++) {
		if (pbssLine->getString(i)->search(aszKey) >= 0) {

			pbsResult->append(pbssLine->getString(i));

			pbsResult->append("\r\n");

			iResultLine++;

		}
	}

	SetWindowText(g_hwView, pbsResult->c_str());

	wsprintf(aszStatus, "S%ds", iResultLine);

	SetWindowText(g_hwStatus, aszStatus);

	delete pbssLine;
	delete pbsResult;

}

/* 폜 */
void del() {

	char aszKey[256], aszStatus[64];
	char *lpszText;

	GetWindowText(g_hwKey, aszKey, 256);

	if (lstrlen(aszKey) < 1) {
		return;
	}

	/* b`eLXg̕擾 */
	int iLength = SendMessage(g_hwView, WM_GETTEXTLENGTH, 0, 0) + 1;

	lpszText = new char[iLength];

	/* b`eLXg̕擾 */
	SendMessage(g_hwView, WM_GETTEXT, (WPARAM)iLength, (LPARAM)lpszText);

	B2String1 *pbsText = new B2String1(lpszText);

	delete lpszText;

	/* s\nɓ */
	pbsText->replace("\r\n", "\n");

	/* sPʂɐ؂蕪 */
	B2Strings *pbssLine = pbsText->split("\n");

	delete pbsText;

	if (pbssLine == NULL) {

		SetWindowText(g_hwStatus, "");

		return;

	}

	int iLine = pbssLine->getSize();
	int iResultLine = 0;

	/* ʊi[p񐶐 */
	B2String1 *pbsResult = new B2String1();

	for (int i = 0;i < iLine;i++) {
		if (pbssLine->getString(i)->search(aszKey) == -1 && pbssLine->getString(i)->getChr(0) != 0) {

			pbsResult->append(pbssLine->getString(i));

			pbsResult->append("\r\n");

			iResultLine++;

		}
	}

	SetWindowText(g_hwView, pbsResult->c_str());

	wsprintf(aszStatus, "S%ds", iResultLine);

	SetWindowText(g_hwStatus, aszStatus);

	delete pbssLine;
	delete pbsResult;

}

/* w蕶܂ł폜 */
void delFrom() {

	char aszKey[256], aszStatus[64];
	char *lpszText;

	GetWindowText(g_hwKey, aszKey, 256);

	if (lstrlen(aszKey) < 1) {
		return;
	}

	/* b`eLXg̕擾 */
	int iLength = SendMessage(g_hwView, WM_GETTEXTLENGTH, 0, 0) + 1;

	lpszText = new char[iLength];

	/* b`eLXg̕擾 */
	SendMessage(g_hwView, WM_GETTEXT, (WPARAM)iLength, (LPARAM)lpszText);

	B2String1 *pbsText = new B2String1(lpszText);

	delete lpszText;

	/* s\nɓ */
	pbsText->replace("\r\n", "\n");

	/* sPʂɐ؂蕪 */
	B2Strings *pbssLine = pbsText->split("\n");

	delete pbsText;

	if (pbssLine == NULL) {

		SetWindowText(g_hwStatus, "");

		return;

	}

	int iLine = pbssLine->getSize();
	int iResultLine = 0;

	/* ʊi[p񐶐 */
	B2String1 *pbsResult = new B2String1();

	for (int i = 0;i < iLine;i++) {
		if (pbssLine->getString(i)->search(aszKey) > 0 && pbssLine->getString(i)->getChr(0) != 0) {

			int index = pbssLine->getString(i)->search(aszKey);

			for (int j = 0;j < index;j++) {
				pbssLine->getString(i)->del(0);
			}

			pbsResult->append(pbssLine->getString(i));

			pbsResult->append("\r\n");

			iResultLine++;

		} else {

			if (pbssLine->getString(i)->getChr(0) != 0) {

				pbsResult->append(pbssLine->getString(i));

				pbsResult->append("\r\n");

				iResultLine++;

			}

		}
	}

	SetWindowText(g_hwView, pbsResult->c_str());

	wsprintf(aszStatus, "S%ds", iResultLine);

	SetWindowText(g_hwStatus, aszStatus);

	delete pbssLine;
	delete pbsResult;

}

/* v */
void num() {

	char aszKey[257], aszStatus[64], aszResult[256];
	char *lpszText;

	GetWindowText(g_hwKey, aszKey, 257);

	if (lstrlen(aszKey) < 1 || lstrlen(aszKey) > 255) {
		return;
	}

	/* b`eLXg̕擾 */
	int iLength = SendMessage(g_hwView, WM_GETTEXTLENGTH, 0, 0) + 1;

	/* b`eLXg擾pobt@ */
	lpszText = new char[iLength];

	/* b`eLXg̕擾 */
	SendMessage(g_hwView, WM_GETTEXT, (WPARAM)iLength, (LPARAM)lpszText);

	/* 󂯎ŕNX */
	B2String1 *pbsText = new B2String1(lpszText);

	delete lpszText;

	/* s\nɓ */
	pbsText->replace("\r\n", "\n");

	/* sPʂɐ؂蕪 */
	B2Strings *pbssLine = pbsText->split("\n");

	delete pbsText;

	if (pbssLine == NULL) {

		SetWindowText(g_hwStatus, "");

		return;

	}

	int iLine = pbssLine->getSize();
	int iNum = 0;

	for (int i = 0;i < iLine;i++) {
		if (pbssLine->getString(i)->search(aszKey) >= 0) {
			iNum++;
		}
	}

	wsprintf(aszStatus, "S%ds", iLine);

	SetWindowText(g_hwStatus, aszStatus);

	wsprintf(aszResult, "S%d", iNum);

	MessageBox(g_hwMain, aszResult, aszKey, MB_OK);

	delete pbssLine;

}
